"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.Plot = void 0;

const interval_1 = require("./interval"), line_1 = require("./line"), cell_1 = require("./cell"), rule_x_1 = require("./rule-x"), rule_y_1 = require("./rule-y"), area_1 = require("./area"), plot_1 = require("./plot");

Object.defineProperty(exports, "Plot", {
    enumerable: !0,
    get: function() {
        return plot_1.Plot;
    }
});

const image_1 = require("./image"), path_1 = require("./path"), polygon_1 = require("./polygon"), rect_x_1 = require("./rect-x"), rect_y_1 = require("./rect-y"), rect_1 = require("./rect"), rule_1 = require("./rule"), symbol_1 = require("./symbol"), text_1 = require("./text"), sankey_1 = require("./sankey"), sunburst_1 = require("./sunburst"), treemap_1 = require("./treemap"), circle_packing_1 = require("./circle-packing"), tree_1 = require("./tree"), wordcloud_1 = require("./wordcloud"), wordcloud_shape_1 = require("./wordcloud-shape");

plot_1.Plot.useMarks([ interval_1.Interval, line_1.Line, cell_1.Cell, rule_x_1.RuleX, rule_y_1.RuleY, area_1.Area, image_1.ImageSemanticMark, path_1.PathSemanticMark, polygon_1.PolygonSemanticMark, rect_1.RectSemanticMark, rect_x_1.RectXSemanticMark, rect_y_1.RectYSemanticMark, rule_1.Rule, symbol_1.SymbolSemanticMark, text_1.TextSemanticMark, sankey_1.SankeySemanticMark, sunburst_1.SunburstSemanticMark, treemap_1.TreemapSemanticMark, circle_packing_1.CirclePackingSemanticMark, tree_1.TreeSemanticMark, wordcloud_1.WordcloudSemanticMark, wordcloud_shape_1.WordcloudShapeSemanticMark ]);
//# sourceMappingURL=plot-all.js.map